As a security precaution, we have turned on the setting "Require API key authentication for API requests" for everyone. If this has broken something, please contact bugzilla-admin@mozilla.org
Last Comment Bug 56488 - Down scroll arrow hidden, draws behind resize widget when neither Status Bar nor horizontal scrollbar are displayed
: Down scroll arrow hidden, draws behind resize widget when neither Status Bar ...
Status: RESOLVED FIXED
relnote-user
: pp
Product: Core
Classification: Components
Component: Widget: Cocoa (show other bugs)
: Trunk
: PowerPC Mac OS X
: P3 normal with 17 votes (vote)
: mozilla1.9.1a2
Assigned To: Markus Stange [:mstange]
:
: Markus Stange [:mstange]
Mentors:
http://bugzilla.mozilla.org/query.cgi
: 61234 88817 89301 98125 108503 111004 124527 138149 140364 142320 147295 153565 157306 161738 162898 169082 170223 173991 174917 181876 182668 183719 186486 189957 191648 211909 215362 222317 225116 226503 229892 235165 263328 269417 275236 280025 302021 319556 342751 358328 379756 382955 387259 408907 411229 413308 426704 428504 434765 434889 447953 451559 457378 457740 468019 481420 488471 501055 (view as bug list)
Depends on: 451641 461865
Blocks: 159233 193527 macmeta
  Show dependency treegraph
 
Reported: 2000-10-13 12:05 PDT by Kathleen Brade
Modified: 2014-01-10 10:39 PST (History)
82 users (show)
samuel.sidler+old: in‑testsuite?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Screenshot (PNG) of hidden bottom arrow on Mac OS X (8.49 KB, image/png)
2002-03-06 03:00 PST, Matt Lee
no flags Details
no righthand horizontal scroll arrow in Source window under Mac OS 9.2.2 (778 bytes, image/png)
2002-08-17 00:22 PDT, wighta
no flags Details
Scrollbar arrow missing in help window, compared to standard window (4.20 KB, image/gif)
2002-09-22 17:04 PDT, Frederic Kayser
no flags Details
No Scrollbars (OS 10.2.8) (37.61 KB, image/jpeg)
2004-04-28 06:59 PDT, Yoshimi
no flags Details
patch (1.85 KB, patch)
2005-01-11 11:16 PST, Ari
jhpedemonte: review-
Details | Diff | Splinter Review
test case (375 bytes, text/html)
2005-06-08 14:30 PDT, jhp (no longer active)
no flags Details
No DOWN scroll arrow (5.27 KB, image/png)
2007-08-14 01:59 PDT, Bob Tyson
no flags Details
fix v0.1 (9.16 KB, patch)
2008-08-06 07:23 PDT, Markus Stange [:mstange]
no flags Details | Diff | Splinter Review
the real fix v0.1 (9.06 KB, patch)
2008-08-06 07:34 PDT, Markus Stange [:mstange]
no flags Details | Diff | Splinter Review
the real real fix v0.1 (9.05 KB, patch)
2008-08-06 07:52 PDT, Markus Stange [:mstange]
no flags Details | Diff | Splinter Review
fix v1.0: rev nsIWidget uuid (9.81 KB, patch)
2008-08-06 11:37 PDT, Markus Stange [:mstange]
no flags Details | Diff | Splinter Review
testcase (443 bytes, text/html)
2008-08-06 16:37 PDT, Robert O'Callahan (:roc) (email my personal email if necessary)
no flags Details
fix v2.0 (10.10 KB, patch)
2008-08-07 10:02 PDT, Markus Stange [:mstange]
roc: review+
roc: superreview+
Details | Diff | Splinter Review
fix comment (10.10 KB, patch)
2008-08-08 04:48 PDT, Markus Stange [:mstange]
no flags Details | Diff | Splinter Review
Screenshot snippets showing the problem (FF 3.0.6) (54.08 KB, image/jpeg)
2009-02-08 18:32 PST, Julian
no flags Details

Description User image Kathleen Brade 2000-10-13 12:05:41 PDT
In a navigator window, go to the above url:  (bugzilla's query page)
Choose View Source from the menu (or command-u)
Notice that the bottom arrow of the scrollbar seems to be under the growbox.
Also notice that I don't have a horizontal scrollbar even though the text scrolls 
off the right edge of the window.

On Linux, I see both scrollbars and the resize corner is not obscureed (not that 
it would be on Linux tho).
Comment 1 User image Mike Pinkerton (not reading bugmail) 2000-10-13 12:08:39 PDT
pushing to don's team. there are so many problems with this window, I can't even
count them.
Comment 2 User image Simon Fraser 2000-10-13 12:26:28 PDT
Pink files this ages ago. It's a generic chrome problem; they need to take the 
Mac's resize widget into account.
Comment 3 User image Kathleen Brade 2000-10-13 12:44:20 PDT
the right thing seems to happen on Linux... there is space for one on Linux 
(though linux doesn't need it).

Maybe the real problem is that the horizontal scrollbar is missing?
Comment 4 User image Asa Dotzler [:asa] 2000-10-13 20:09:23 PDT
workaround, use Edit Page HTML Source view ;)  We should just replace view
source with that.  
Comment 5 User image Doron Rosenberg (IBM) 2000-10-14 14:30:52 PDT
setting default qa (se), who hopefully has access to a mac to better service
this bug
Comment 6 User image sairuh (rarely reading bugmail) 2000-10-16 14:44:56 PDT
pink/simon, either of you remember the bug# for this problem pink filed? thx!
Comment 7 User image Simon Fraser 2000-10-16 15:28:01 PDT
Hrm, no.

What's odd here is that sometimes the bottom scrollbar shows up, and sometimes 
not. It seems to depend on what the source is like (though, in both cases, the 
source can be wide enough that there ought to be a scrollbar).
Comment 8 User image Viswanath Ramachandran 2000-12-06 11:26:35 PST
Since Don has left, Vishy is taking his bugs in bulk, pending reassignment.
thanks,
	Vishy
Comment 9 User image Viswanath Ramachandran 2001-01-11 17:30:44 PST
nav triage team: not a beta stopper. 
Comment 10 User image Håkan Waara 2001-02-17 17:08:53 PST
If I understood the description correctly, this doesn't happen for me anymore.
Can anyone else still reproduce this?
Comment 11 User image Paul Chen 2001-03-20 10:35:51 PST
Marking nsbeta1- bugs as future to get off the radar.
Comment 12 User image Nick Meara 2001-07-26 07:57:21 PDT
I think that this has been fixed for a while. I can certainly see the bottom
vertical scroll arrow and the entire horizontal scrollbar in the 'Source' window
listing for the Bugzilla Query page URL.

I'm using the 2001-07-12-08 build on Mac OS 9.1 and the 2001-07-24-08 build on
Mac OS 8.6.
Comment 13 User image Mike Pinkerton (not reading bugmail) 2001-07-26 13:37:11 PDT
i think this is only a problem when there is no horizontal scrollbar, so the 
vertical scrollbar goes all the way to the bottom of the window.
Comment 14 User image Nick Meara 2001-07-27 01:39:23 PDT
Oops! You're right, Mike. It's the same when there's only a horizontal scrollbar
and no vertical one. View the source of http://www.eastern.co.uk for an example.
Comment 15 User image Blake Ross 2001-10-13 14:17:51 PDT
--> view source owner
Comment 16 User image sairuh (rarely reading bugmail) 2002-01-24 14:48:09 PST
mass moving open bugs pertaining to view source to pmac@netscape.com as qa contact.

to find all bugspam pertaining to this, set your search string to
"ItsSharkeysNight".
Comment 17 User image John Levon 2002-02-23 16:52:41 PST
*** Bug 108503 has been marked as a duplicate of this bug. ***
Comment 18 User image John Levon 2002-02-23 16:59:33 PST
change summary to reflect generic status. The horizontal scrollbar
thing needs to go in a different bug.

Feel free to flame like hell if I fucked up...
Comment 19 User image timeless 2002-02-23 19:35:56 PST
i presume this isn't a themes issue...
Comment 20 User image Chris Lyon 2002-02-23 23:33:05 PST
*** Bug 124527 has been marked as a duplicate of this bug. ***
Comment 21 User image Matt Lee 2002-03-06 03:00:43 PST
Created attachment 72770 [details]
Screenshot (PNG) of hidden bottom arrow on Mac OS X

This illustrates the bug still occuring on Mac OS X (build 2002030508), in the
Bookmark Manager window, in comparison to a browser window which does not
exhibit the problem.
Comment 22 User image Greg K. 2002-07-23 11:05:17 PDT
*** Bug 61234 has been marked as a duplicate of this bug. ***
Comment 23 User image Greg K. 2002-07-23 11:06:07 PDT
*** Bug 88817 has been marked as a duplicate of this bug. ***
Comment 24 User image Greg K. 2002-07-23 11:07:51 PDT
*** Bug 89301 has been marked as a duplicate of this bug. ***
Comment 25 User image Greg K. 2002-07-23 11:11:37 PDT
*** Bug 140364 has been marked as a duplicate of this bug. ***
Comment 26 User image Greg K. 2002-07-23 11:12:14 PDT
*** Bug 153565 has been marked as a duplicate of this bug. ***
Comment 27 User image Greg K. 2002-07-23 11:12:50 PDT
*** Bug 157306 has been marked as a duplicate of this bug. ***
Comment 28 User image Greg K. 2002-07-23 14:55:01 PDT
*** Bug 138149 has been marked as a duplicate of this bug. ***
Comment 29 User image Greg K. 2002-07-23 14:55:50 PDT
*** Bug 142320 has been marked as a duplicate of this bug. ***
Comment 30 User image Benjamin Mucci 2002-07-23 18:02:16 PDT
*** Bug 98125 has been marked as a duplicate of this bug. ***
Comment 31 User image Terri Preston 2002-08-08 16:39:55 PDT
*** Bug 161738 has been marked as a duplicate of this bug. ***
Comment 32 User image Daniel Wang 2002-08-15 22:10:44 PDT
*** Bug 162898 has been marked as a duplicate of this bug. ***
Comment 33 User image Daniel Wang 2002-08-15 22:18:13 PDT
*** Bug 147295 has been marked as a duplicate of this bug. ***
Comment 34 User image wighta 2002-08-17 00:22:42 PDT
Created attachment 95684 [details]
no righthand horizontal scroll arrow in Source window under Mac OS 9.2.2
Comment 35 User image wighta 2002-08-17 00:27:28 PDT
I have confirmed this bug using both the Modern theme and the 'Little Mozilla
1.1' theme. See attachment id=95684 which shows the lack of this arrow.

Mac OS 9.2.2 English-North American
Mozilla/5.0 (Macintosh; U; PPC; en-US; rv:1.1) Gecko/20020814
Build ID 2002081422

Why no patch after nearly 5 months? Isn't the idea to be *better* than MS IE ?
Comment 36 User image Frank J. R. Hanstick 2002-08-29 16:49:13 PDT
I downloaded and installed Build ID: 2002082808 only to find that the scroll
arrows no longer initiate scrolling in either direction.  They do highlight when
selected; but, no scrolling takes place.  The ability to intiate scrolling via
moving the cursor in or around the highlighted control is also no longer
present.  What changed?
Comment 37 User image Greg K. 2002-08-29 17:10:15 PDT
Frank, that's bug 161365, not this one.
Comment 38 User image Greg K. 2002-09-17 17:19:21 PDT
*** Bug 169082 has been marked as a duplicate of this bug. ***
Comment 39 User image Greg K. 2002-09-22 15:48:29 PDT
*** Bug 170223 has been marked as a duplicate of this bug. ***
Comment 40 User image Greg K. 2002-09-22 15:50:18 PDT
*** Bug 111004 has been marked as a duplicate of this bug. ***
Comment 41 User image Frederic Kayser 2002-09-22 17:04:57 PDT
Created attachment 100183 [details]
Scrollbar arrow missing in help window, compared to standard window

This bug is still alive, after two years!?

Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-US; rv:1.1) Gecko/20020826

Steps to Reproduce:
1. Open the Help window
2. Select a topic with a lot of content (Browsing the web)
3. Look at the lower right corner of the window, there is no down arrow !
Comment 42 User image Greg K. 2002-10-12 11:40:23 PDT
*** Bug 173991 has been marked as a duplicate of this bug. ***
Comment 43 User image Jean-Pierre Melkonian 2002-10-12 12:11:24 PDT
There are two test case for "View Source" in bug Bug 173991 

Comment 13 of this one is right
Comment 44 User image Greg K. 2002-10-17 10:43:17 PDT
*** Bug 174917 has been marked as a duplicate of this bug. ***
Comment 45 User image Bjarne D Mathiesen 2002-10-23 01:20:20 PDT
Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-US; rv:1.2b) 
Gecko/20021016 MultiZilla/v1.1.21

This bug is also seen in some cases where a new browser window is opened through
a javascript. Go to : 
http://www.wired.com/news/mac/0,2125,55395-2,00.html
and click on one of the thumbnails.

Also, if you go to Menu: View -> Show/Hide -> Status Bar and toggle this off for
a normal browser window (like the one you are watching now), the bottom arrow
disappears below the window growbox. Thus, this bug seems to be dependent on
whether a status bar is displayed or not. 
Comment 46 User image External Brainz [Hendrik W.] 2002-10-27 04:22:27 PST
This bug keeps annoying me, and it is REALLY annoying.

When clicking the 'toggle toolbar' button in the right corner of the OS X title
bar, wich i do often to make more room available, the down-arrow of the vertical
scrollbar disappears behind the resize-thing...

I have a (very simple) workaround in mind, wich would make life much easier for
me: do not make the status bar disappear when clicking on the 'toggle toolbar'
button. I've already disallowed scripts to remove the status bar, so i the bug
really only bugs me when using the toggle toolbar button.

Personally i think this would be ideal for OS X users. (At least as an option...
I don't mind losing 18 pixels of space, now i'm not using the toggle function
i'm 'losing' far more...)
Comment 47 User image External Brainz [Hendrik W.] 2002-11-07 16:32:59 PST
Maybe I'm stupid, and handling against all bugzilla rules, but dear developers,
will you please NOT FORGET this bug!
Comment 48 User image R.K.Aa. 2002-11-25 11:04:57 PST
*** Bug 181876 has been marked as a duplicate of this bug. ***
Comment 49 User image R.K.Aa. 2002-11-29 09:25:33 PST
*** Bug 182668 has been marked as a duplicate of this bug. ***
Comment 50 User image R.K.Aa. 2002-12-05 08:30:57 PST
*** Bug 183719 has been marked as a duplicate of this bug. ***
Comment 51 User image Greg K. 2002-12-05 14:59:55 PST
Please, refrain from adding evangelical comments. Contribute code, or just vote
for it.
Comment 52 User image Martyr 2002-12-05 16:37:40 PST
Yes, it is highly annoying and bothersome to deal with "evangelical" comments --
strong words actually have effects, you know, and sometimes they actually
motivate people. We must have None Of That! And for dealing with a bug that has
been opened for two years, why nothing is more appropriate than steadfast
silence! After all, it's a commonly-known truth in the open source world that
everyone can code just as well as everyone else! Why don't I just submit the fix
myself instead of being a bug senteniel and beta-testing the product? I should
immediately forgo all of those activities (and my own Moz evangelism, too,
because evangelism is a big no-no apparently) and just vote or code. But on the
serious side of the fence, it is absolutely preposterous to expect bugs with
long histories to NOT have their occasional posts by frustrated users. 

Comment 53 User image Hendrik W. [The Account Loser] 2002-12-08 15:47:54 PST
Thanks for the help, Tarage,

Well, I WOULD certainly contribute a fix for this bug, if i had te required
programming knowledge. I am not (yet!) a programmer, so i am relying 0n the
great work of the Moz engineers. (Moz is a great job after all!) It just annoys
me that the app is unpolished in some ways. This bug is easy to workaround (i
cannot imagine that it is hard for a programmer to implement a 'NEVER hide the
status bar' option) but there is NOt A SINGLE ONE of the great developers fixing
it or making a workaround, or even watching this tread. That annoys me...

No offence to anyone... I just want a 'Never hide the status bar' option so this
bug wioll never bug me again...
Comment 54 User image u60234 2002-12-22 12:58:12 PST
*** Bug 186486 has been marked as a duplicate of this bug. ***
Comment 55 User image Jo Hermans 2003-01-21 11:55:32 PST
*** Bug 189957 has been marked as a duplicate of this bug. ***
Comment 56 User image Frankie 2003-02-09 17:23:55 PST
*** Bug 191648 has been marked as a duplicate of this bug. ***
Comment 57 User image Bruce Davidson 2003-08-27 13:43:46 PDT
*** Bug 211909 has been marked as a duplicate of this bug. ***
Comment 58 User image louis bennett 2003-10-15 19:22:31 PDT
*** Bug 222317 has been marked as a duplicate of this bug. ***
Comment 59 User image Stefan [:stefanh] 2003-11-09 14:30:40 PST
*** Bug 225116 has been marked as a duplicate of this bug. ***
Comment 60 User image Daniel Wang 2003-11-22 03:50:26 PST
*** Bug 226503 has been marked as a duplicate of this bug. ***
Comment 61 User image Tuukka Tolvanen (sp3000) 2004-04-24 06:07:40 PDT
*** Bug 229892 has been marked as a duplicate of this bug. ***
Comment 62 User image Yoshimi 2004-04-28 06:59:53 PDT
Created attachment 147227 [details]
No Scrollbars (OS 10.2.8)
Comment 63 User image Yoshimi 2004-04-28 07:05:58 PDT
I'm finding that on some pages there are no scrollbars at all, on others,
there's just a blank scrollbar... then some are fine.
Comment 64 User image Wayne Woods 2004-09-23 07:25:46 PDT
*** Bug 235165 has been marked as a duplicate of this bug. ***
Comment 65 User image Uri Bernstein (Google) 2004-10-08 05:27:14 PDT
*** Bug 263328 has been marked as a duplicate of this bug. ***
Comment 66 User image Uri Bernstein (Google) 2004-11-13 01:28:06 PST
*** Bug 269417 has been marked as a duplicate of this bug. ***
Comment 67 User image Ari 2005-01-11 11:16:56 PST
Created attachment 170944 [details] [diff] [review]
patch

Makes nsNativeScrollbar care about the grow box
Comment 68 User image Simon Fraser 2005-01-11 17:33:00 PST
This looks OK, but what about the modern skin?
Comment 69 User image Stefan [:stefanh] 2005-04-03 16:42:23 PDT
*** Bug 275236 has been marked as a duplicate of this bug. ***
Comment 70 User image jhp (no longer active) 2005-06-08 14:19:01 PDT
Comment on attachment 170944 [details] [diff] [review]
patch

This won't work, since it resizes any scrollbar, whether or not it actually
hides behind the grow box.  I'll attach a patch that shows the issue.

What's really needed is to see if the scroll bar actually overlaps the grow
box, and only then resize it.
Comment 71 User image jhp (no longer active) 2005-06-08 14:30:08 PDT
Created attachment 185715 [details]
test case

In this testcase, the scrollbar in the middle of the page should span the full
document (should go off the page on the right).  And the bottom scrollbar
should look correct and have the right arrow button visible, when the status
bar is both visible and hidden (View->Status Bar).
Comment 72 User image jhp (no longer active) 2005-06-08 14:34:44 PDT
As for fixing other themes, this is what roc suggested on IRC:

roc:	add an API to nsIWidget that nsGfxScrollFrameInner can call
        to see if it needs to reserve space, and if so, how much?
	or just to check if it needs to at all.
roc:	this API would return true if the widget has a native resizer
	then nsXULScrollFrame would have to reserve space as if there
        are two scrollbars.
	I guess this doesn't matter for nsHTMLScrollFrame since we
        currently don't allow windows to be just HTML.
Comment 73 User image jhp (no longer active) 2005-06-21 12:17:12 PDT
*** Bug 215362 has been marked as a duplicate of this bug. ***
Comment 74 User image jhp (no longer active) 2005-06-21 12:18:53 PDT
Adding 'hidden' to summary, to allow better search hits.
Comment 75 User image Stefan [:stefanh] 2005-07-08 12:20:43 PDT
*** Bug 280025 has been marked as a duplicate of this bug. ***
Comment 76 User image Jo Hermans 2005-07-28 09:24:43 PDT
*** Bug 302021 has been marked as a duplicate of this bug. ***
Comment 77 User image Stefan [:stefanh] 2005-12-08 08:35:53 PST
*** Bug 319556 has been marked as a duplicate of this bug. ***
Comment 78 User image :Gavin Sharp [email: gavin@gavinsharp.com] 2006-06-27 06:01:26 PDT
*** Bug 342751 has been marked as a duplicate of this bug. ***
Comment 79 User image Stefan [:stefanh] 2006-10-27 03:28:20 PDT
*** Bug 358328 has been marked as a duplicate of this bug. ***
Comment 80 User image Al 2007-04-26 15:19:09 PDT
(In reply to comment #79)
> *** Bug 358328 has been marked as a duplicate of this bug. ***
> 

I'm running Mac OS X. 10.3.9 with Firefox 2.0.0.3 and this bug just popped up a few weeks ago. Is that any clue?
Comment 81 User image Jan van Cort 2007-04-26 15:41:15 PDT
I have since moved to OS X 10.4.9 and have not seen the bug since, because of this I am removing myself from the copy list.

Comment 82 User image Stefan [:stefanh] 2007-05-04 13:58:40 PDT
*** Bug 379756 has been marked as a duplicate of this bug. ***
Comment 83 User image :Gavin Sharp [email: gavin@gavinsharp.com] 2007-06-03 07:49:29 PDT
*** Bug 382955 has been marked as a duplicate of this bug. ***
Comment 84 User image Stuart Morgan 2007-06-14 23:54:48 PDT
With the new scrollbar implementation, would it be possible to fix this by changing the way the painting and hit-detection is mapped to and from HITheme, so that it's shorter from HITheme's perspective without Gecko having to know about it?
Comment 85 User image Smokey Ardisson (offline for a while; not following bugs - do not email) 2007-06-15 08:13:12 PDT
Moving to a component that's still relevant in 2007.
Comment 86 User image Bob Tyson 2007-08-14 01:57:28 PDT
YES this bug is alive and well under OSX 10.4.10, Firefox 2.0.0.6 AND Minefield 3.0a8pre.  (iBook G4) A real fix would be much appreciated by THIS user.

Recap: ONLY the 'UP' scroll arrow is visible/useable at the screen/page lower right in many/majority of web pages. (But recalling comment above, SOME pages work properly.) 

If I can understand how to u/l a small screen shot (titled no_down.png) it will show this defect appearing on THIS page. Also www.nytimes.com, etc etc.

Turning on Status Bar (View Menu) or opening a Find window cause the paired UP/DOWN scroll arrows to appear and operate properly.
Comment 87 User image Bob Tyson 2007-08-14 01:59:21 PDT
Created attachment 276607 [details]
No DOWN scroll arrow

Note my comment added 14 august - Bob Tyson
Comment 88 User image Stuart Morgan 2007-08-14 07:15:56 PDT
The existence of this bug is well known; comments saying that it's still present aren't necessary.
Comment 89 User image Bob Tyson 2007-08-15 01:38:19 PDT
I thank Mr. Morgan for his 'avviso' but would point out that I have long scratched my head at this particular Firefox defect. AND gnashed my teeth. Not a pro visitor to Bugzilla, I did what I hoped was 'due diligence' (which consumed a not small amount of my time and patience) in the FAQs, lists, and so on, before adding my notes above. I  think that not inappropriate, but would add my sincere wish that the extra email or two to those following this will NOT be read as 'hurry-up' flags, so much as 'hey, it IS still a bit of craziness' out here.

Mozilla so far as I know gets around this problem...

I note that the first FAQ in the Gran Paradiso development page says

#  What can I do to help?

We need help from developers and the testing community to provide as much feedback as possible to make Firefox even better. 

Ecco, ci qua... da Torino
Comment 90 User image Mr Lizard 2007-10-07 16:42:52 PDT
Worth noting some users, like me, prefer to have the statusbar turned off (looks more mac-like, plus with fission extension the progress bar is placed with the address bar so no need for statusbar)

Instead of hide statusbar, any way to make the statusbar only take up the space underneath the scrollbar arrows? Thus pushing down arrow back up into view again
Comment 91 User image Colin Barrett [:cbarrett] 2007-10-08 10:07:09 PDT
That, I think, is the plan.
Comment 92 User image Stuart Morgan 2007-10-30 07:38:47 PDT
*** Bug 157306 has been marked as a duplicate of this bug. ***
Comment 93 User image Stefan [:stefanh] 2007-12-19 14:44:20 PST
*** Bug 408907 has been marked as a duplicate of this bug. ***
Comment 94 User image Phil Ringnalda (:philor) 2008-01-09 13:40:21 PST
*** Bug 411229 has been marked as a duplicate of this bug. ***
Comment 95 User image Jo 2008-01-09 20:35:59 PST
To clarify, this bug applies to the main window and Places window in addition to the view source window.
Comment 96 User image Steven Michaud [:smichaud] (Retired) 2008-01-11 12:30:51 PST
*** Bug 411230 has been marked as a duplicate of this bug. ***
Comment 97 User image Don Ernst 2008-04-25 14:03:14 PDT
Mac OS 10.5.2 Firefox 3.0b5. This has been going on for a long time in Firefox 2 as well as various beta releases.  The down scroll arrow is missing or in the same place as the expand square. It happens on all original screens using Firefox.  The down scroll arrow  usually works correctly on linked pages.
It happens whether the up arrow is at the top or the bottom of the scroll bar.  Past time to solve problem.
Comment 98 User image Chris Lawson (gone) 2008-04-25 14:06:58 PDT
Don, please read

https://bugzilla.mozilla.org/page.cgi?id=etiquette.html

especially point 1, before commenting further. Everyone is well aware that this bug is present. If it were easy to fix, it would have been done by now.
Comment 99 User image Chris Lawson (gone) 2008-04-25 15:57:38 PDT
(In reply to comment #91)
> That, I think, is the plan.

Colin, when you said the above, did "that" refer to the immediately preceding comment (comment 90), or to Stuart's comment 84, or to something else entirely?

What *is* the current plan for this, in other words? I'm assuming the stuff from 2005 and earlier isn't still relevant now.
Comment 100 User image Stefan [:stefanh] 2008-04-26 04:42:45 PDT
I think the plan was to fix this in bug 363757. 
Comment 101 User image Markus Stange [:mstange] 2008-06-15 15:57:39 PDT
*** Bug 434765 has been marked as a duplicate of this bug. ***
Comment 102 User image Colin Barrett [:cbarrett] 2008-06-19 20:47:07 PDT
I think the plan then was to fix it as Mr. Lizard described it.

I don't know what the plan is now, I haven't been involved in Gecko development since January 2008.
Comment 103 User image Don Ernst 2008-06-19 21:24:55 PDT
On my 17" screen, MAC 10.5, the down arrow and the resize widget are
separate and the horizontal scroll bar appears when the vertical area 
is full or less and the horizontal area is about 3/4 of the available 
space or less.  The Status Bar is unchecked. The problem seems to occur on a fuller horizontal screen and when an original page like  this one is opened. 
Or, as you expand with  the resize widget one or both problems appear.
It usually, although occasionally, doesn't happen on linked pages.
Comment 104 User image Chris Lawson (gone) 2008-07-10 10:44:14 PDT
*** Bug 387259 has been marked as a duplicate of this bug. ***
Comment 105 User image Don Ernst 2008-07-24 17:27:47 PDT
It appears the vertical down arrow has been solved by the latest revision of Firefox 3.0.1.  The horizontal scroll bar still disappears when more than about 3/4 of the screen is used including this page.
Comment 106 User image Stefan [:stefanh] 2008-07-25 14:40:06 PDT
*** Bug 447953 has been marked as a duplicate of this bug. ***
Comment 107 User image Stefan [:stefanh] 2008-07-25 14:44:23 PDT
*** Bug 413308 has been marked as a duplicate of this bug. ***
Comment 108 User image Stefan [:stefanh] 2008-07-25 14:45:41 PDT
*** Bug 426704 has been marked as a duplicate of this bug. ***
Comment 109 User image Stefan [:stefanh] 2008-07-25 14:46:10 PDT
*** Bug 428504 has been marked as a duplicate of this bug. ***
Comment 110 User image Stefan [:stefanh] 2008-07-25 14:48:14 PDT
*** Bug 434889 has been marked as a duplicate of this bug. ***
Comment 111 User image Markus Stange [:mstange] 2008-08-06 07:23:55 PDT
Created attachment 332529 [details] [diff] [review]
fix v0.1

This fixes it for nsGfxScrollFrames.

Roc, where should I look if I want to fix it for trees, too? I haven't been able to find the right place yet.
Comment 112 User image Markus Stange [:mstange] 2008-08-06 07:34:34 PDT
Created attachment 332531 [details] [diff] [review]
the real fix v0.1

Oops. One check is enough.
Comment 113 User image Markus Stange [:mstange] 2008-08-06 07:52:25 PDT
Created attachment 332534 [details] [diff] [review]
the real real fix v0.1

Sorry for the noise. I really shouldn't trust myself.
Comment 114 User image Markus Stange [:mstange] 2008-08-06 11:37:09 PDT
Created attachment 332564 [details] [diff] [review]
fix v1.0: rev nsIWidget uuid
Comment 115 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:12:06 PDT
(In reply to comment #111)
> Roc, where should I look if I want to fix it for trees, too? I haven't been
> able to find the right place yet.

Heh, I wasn't CCed on the bug :-)

Trees are in layout/xul/base/src/tree/src.
Comment 116 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:33:47 PDT
Hmm.

This approach is a bit strange. So if the viewport has no scrollbar (say the HTML document is overflow:hidden), but you position an overflow:scroll child element so that it has a vertical scrollbar whose down-arrow happens to be at the bottom-right of the window, then we'll tweak its scrollbar to be shorter.

But, if you put the element somewhere away from the window edge, then scroll the overflow:hidden window (e.g. by setting scrollTop/scrollLeft from JS) so that the vertical scrollbar down-arrow is at the bottom-right corner of the window, there's no reflow so the scrollbar will appear under the resizer. So we'd need to do something on scrolling to fix up any scrollbar ends that appeared under the resizer. Which seems weird.

It's also weird that if a vertical scrollbar overlaps the resizer horizontally, then we'll shorten it, but if it misses the resizer horizontally then it will suddenly snap out to its full height (possibly outside the window).

Yet it seems that this behaviour is exactly what Safari does...
Comment 117 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:37:52 PDT
Created attachment 332620 [details]
testcase
Comment 118 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:40:31 PDT
Maybe the issue of scrolling causing an element's scrollbar to fall under the resizer is not worth worrying about and we should just take this patch.
Comment 119 User image Markus Stange [:mstange] 2008-08-06 16:50:12 PDT
(In reply to comment #115)
> Trees are in layout/xul/base/src/tree/src.

Yeah, but where does the scrollbar layout happen? In nsTreeBodyFrame.cpp the scrollbar's attributes (curpos, maxpos, increment, pageincrement) are updated, but I can't see the scrollbar rects anywhere.

(In reply to comment #118)
> Maybe the issue of scrolling causing an element's scrollbar to fall under the
> resizer is not worth worrying about

That's what I thought. When scrolling causes an element's scrollbar to fall under the resizer, there's usually another scrollbar covering that scrollbar.
Comment 120 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:56:29 PDT
+NS_IMETHODIMP nsChildView::AdjustScrollbar(nsRect &aScrollbarRect, PRBool aVertical)

Make this nsIntRect. I'd also prefer to make it a pointer to a rect to make it clear that it's in/out.

+  float overlapWidth = corner.x - (bounds.width - resizeIndicatorSize.width);
+  float overlapHeight = [topLevelView isFlipped] ?
+                        corner.y - (bounds.height - resizeIndicatorSize.height) : 
+                        resizeIndicatorSize.height - corner.y;
+
+  if (overlapWidth > 0.0f && overlapHeight > 0.0f) {

I think it would be more clear if we just computed the intersection of the resizer rect with the scrollbar rect and tested whether they intersect. That would also handle potential bidi situations where the scrollbar is on the left.

+  if ((aVertical && !aRect.width) || (!aVertical && !aRect.height))

if ((aVertical ? aRect.width : aRect.height) == 0)

The rounding issues here are nasty. I think it might make more sense for nsIWidget to return a pixel-rect containing the resizer area, then we can convert that to appunits and adjust the scrollbar rect in AdjustScrollbarRect.
Comment 121 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-06 16:58:32 PDT
(In reply to comment #119)
> (In reply to comment #115)
> > Trees are in layout/xul/base/src/tree/src.
> 
> Yeah, but where does the scrollbar layout happen? In nsTreeBodyFrame.cpp the
> scrollbar's attributes (curpos, maxpos, increment, pageincrement) are updated,
> but I can't see the scrollbar rects anywhere.

Hmm. I think maybe there's an XBL binding for <tree> that creates a standalone XUL scrollbar which uses nsIScrollbarMediator to manage scrolling for the tree? That sounds even harder. I'd tackle that separately, if at all.
Comment 122 User image Don Ernst 2008-08-06 19:32:15 PDT
Curious, to me this does not happen under Thunderbird. 
With the page recized to the bottom of the screen the vertical down arrow is separate from the recizer on Mac Leopard as it should be.

 When the recizer is about 1/2 across the screen the horizontal scroll bar is there. As the recizer is pulled to the right the grey  bar gets longer until it reaches the right end of the space available. Then as the resizer is moved further right the horizontal scroll bar and scroll arrow disappears.
Comment 123 User image Markus Stange [:mstange] 2008-08-07 10:02:57 PDT
Created attachment 332744 [details] [diff] [review]
fix v2.0

Like this?

(In reply to comment #121)
> Hmm. I think maybe there's an XBL binding for <tree> that creates a standalone
> XUL scrollbar which uses nsIScrollbarMediator to manage scrolling for the tree?

Uh yeah, I think that's it. Thanks.
Comment 124 User image Markus Stange [:mstange] 2008-08-07 10:09:49 PDT
Comment on attachment 332744 [details] [diff] [review]
fix v2.0

The logic in AdjustScrollbarRect can only deal with resizers in the bottom right corner but I think that's enough until we discover an OS that puts it somewhere else.
Comment 125 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-07 16:29:22 PDT
Comment on attachment 332744 [details] [diff] [review]
fix v2.0

+     * Ignored on any platform that does not support it.

"Returns false on..."
Comment 126 User image Markus Stange [:mstange] 2008-08-08 04:48:04 PDT
Created attachment 332919 [details] [diff] [review]
fix comment
Comment 128 User image Markus Stange [:mstange] 2008-08-12 08:07:07 PDT
Comment on attachment 332919 [details] [diff] [review]
fix comment

Camino needs this (bug 159233).
Comment 129 User image Samuel Sidler (old account; do not CC) 2008-08-12 10:39:48 PDT
Can this code be tested? At the very least, can the layout code be tested? I'd prefer to see some tests before considering this for 1.9.0.x. It also needs to bake for a while...
Comment 130 User image Markus Stange [:mstange] 2008-08-13 13:06:50 PDT
I don't know - roc, can it be tested? Maybe with a mochitest that opens a new dialog, puts an overflow:auto box in the corner, synthesizes a mouseclick on the corner and checks if the box has been scrolled?
Comment 131 User image Markus Stange [:mstange] 2008-08-13 13:08:04 PDT
Actually, that sounds possible. I'll try it.
Comment 132 User image Robert O'Callahan (:roc) (email my personal email if necessary) 2008-08-13 15:31:05 PDT
Just make sure the test still works even if the test machine has non-default settings for where the scroll arrows go.

Another option is to use canvas.drawWindow in mochitest to do a "manual" reftest of the appearance of a window with resizer.
Comment 133 User image Samuel Sidler (old account; do not CC) 2008-08-15 02:16:58 PDT
Comment on attachment 332919 [details] [diff] [review]
fix comment

Moving approval request out. This should probably get more baking before landing in 1.9.0.x and should also have a few tests.
Comment 134 User image Markus Stange [:mstange] 2008-08-21 16:03:45 PDT
Comment on attachment 332919 [details] [diff] [review]
fix comment

This caused bug 451641, so I'm removing the approval request for now.
Comment 135 User image Steven Michaud [:smichaud] (Retired) 2008-09-29 14:52:11 PDT
*** Bug 457378 has been marked as a duplicate of this bug. ***
Comment 136 User image Stefan [:stefanh] 2008-09-29 15:15:23 PDT
*** Bug 451559 has been marked as a duplicate of this bug. ***
Comment 137 User image Stefan [:stefanh] 2008-09-29 15:17:45 PDT
*** Bug 457740 has been marked as a duplicate of this bug. ***
Comment 138 User image Stefan [:stefanh] 2008-10-05 12:51:09 PDT
*** Bug 457740 has been marked as a duplicate of this bug. ***
Comment 139 User image Stefan [:stefanh] 2008-12-05 14:30:01 PST
*** Bug 468019 has been marked as a duplicate of this bug. ***
Comment 140 User image Julian 2009-02-08 18:32:51 PST
Created attachment 361209 [details]
Screenshot snippets showing the problem (FF 3.0.6)
Comment 141 User image Julian 2009-02-08 18:38:24 PST
See attachment 361209 [details]. This issue is not resolved in FF 3.0.6 (and remained a problem all through 2.X). System is OS X 10.4, problem occurs regardless of whether or not scroll buttons are grouped in System Preferences -> Appearance. Should be a simple fix by drawing on the same code that positions both scrollbars under X && Y overflow to position scrollbars under X only, or Y only overflow.
Comment 142 User image Markus Stange [:mstange] 2009-02-09 02:20:26 PST
This bug won't be fixed in any Firefox 3.0 version. It's fixed in the 3.1 Betas you can get here: http://www.mozilla.com/en-US/firefox/all-beta.html
Comment 143 User image Markus Stange [:mstange] 2009-03-05 01:40:16 PST
*** Bug 481420 has been marked as a duplicate of this bug. ***
Comment 144 User image Markus Stange [:mstange] 2009-06-29 14:09:24 PDT
*** Bug 501055 has been marked as a duplicate of this bug. ***
Comment 145 User image Stefan [:stefanh] 2009-06-29 14:22:08 PDT
*** Bug 488471 has been marked as a duplicate of this bug. ***
Comment 146 User image Tracy Walker [:tracy] 2014-01-10 10:39:43 PST
mass remove verifyme requests greater than 4 months old

Note You need to log in before you can comment on or make changes to this bug.